VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   0  'None
   Caption         =   "Borderless Edge"
   ClientHeight    =   1605
   ClientLeft      =   105
   ClientTop       =   105
   ClientWidth     =   2550
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1605
   ScaleWidth      =   2550
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Cancel          =   -1  'True
      Caption         =   "&Close"
      Height          =   375
      Left            =   840
      TabIndex        =   2
      Top             =   1020
      Width           =   915
   End
   Begin VB.ComboBox Combo1 
      Height          =   315
      Left            =   240
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   480
      Width           =   2055
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Border&Style:"
      Height          =   195
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *********************************************************************
'  Copyright 2001, Karl E. Peterson, All Rights Reserved.
'  http://www.mvps.org/vb
' *********************************************************************
'  You are free to use this code within your own applications, but you
'  are expressly forbidden from selling or otherwise distributing this
'  source code without prior written consent.
' *********************************************************************
Option Explicit

Private Declare Function DrawEdge Lib "user32" (ByVal hDC As Long, qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long

Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

' Used to support captionless drag
Private Const WM_NCLBUTTONDOWN = &HA1
Private Const HTCAPTION = 2

'/* 3D border styles */
Private Const BDR_RAISEDOUTER = &H1
Private Const BDR_SUNKENOUTER = &H2
Private Const BDR_RAISEDINNER = &H4
Private Const BDR_SUNKENINNER = &H8

Private Const EDGE_RAISED = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)
Private Const EDGE_SUNKEN = (BDR_SUNKENOUTER Or BDR_SUNKENINNER)
Private Const EDGE_ETCHED = (BDR_SUNKENOUTER Or BDR_RAISEDINNER)
Private Const EDGE_BUMP = (BDR_RAISEDOUTER Or BDR_SUNKENINNER)

'/* Border flags */
Private Const BF_LEFT = &H1
Private Const BF_TOP = &H2
Private Const BF_RIGHT = &H4
Private Const BF_BOTTOM = &H8

Private Const BF_TOPLEFT = (BF_TOP Or BF_LEFT)
Private Const BF_TOPRIGHT = (BF_TOP Or BF_RIGHT)
Private Const BF_BOTTOMLEFT = (BF_BOTTOM Or BF_LEFT)
Private Const BF_BOTTOMRIGHT = (BF_BOTTOM Or BF_RIGHT)
Private Const BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)
Private Const BF_DIAGONAL = &H10

Private Const BF_MIDDLE = &H800          '/* Fill in the middle */
Private Const BF_SOFT = &H1000           '/* For softer buttons */
Private Const BF_ADJUST = &H2000         '/* Calculate the space left over */
Private Const BF_FLAT = &H4000           '/* For flat rather than 3D borders */
Private Const BF_MONO = &H8000           '/* For monochrome borders */

Private Sub Combo1_Click()
   Me.Refresh
End Sub

Private Sub Command1_Click()
   Unload Me
End Sub

Private Sub Form_KeyPress(KeyAscii As Integer)
   If KeyAscii = vbKeyEscape Then Unload Me
End Sub

Private Sub Form_Load()
   Me.ScaleMode = vbPixels
   Me.KeyPreview = True
   
   With Combo1
      .AddItem "EDGE_RAISED"
      .ItemData(.NewIndex) = EDGE_RAISED
      .AddItem "EDGE_SUNKEN"
      .ItemData(.NewIndex) = EDGE_SUNKEN
      .AddItem "EDGE_ETCHED"
      .ItemData(.NewIndex) = EDGE_ETCHED
      .AddItem "EDGE_BUMP"
      .ItemData(.NewIndex) = EDGE_BUMP
      .ListIndex = 0
   End With
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
   ' Automatically allow user to drag using
   ' any portion of form, not just titlebar,
   ' when user depresses left mousebutton.
   ' Useful for captionless forms.
   If Button = vbLeftButton Then
      Call ReleaseCapture
      Call SendMessage(Me.hWnd, WM_NCLBUTTONDOWN, HTCAPTION, ByVal 0&)
   End If
End Sub

Private Sub Form_Paint()
   Dim r As RECT
   Dim edge As Long
   
   r.Bottom = Me.ScaleHeight
   r.Right = Me.ScaleWidth
   edge = Combo1.ItemData(Combo1.ListIndex)
   Call DrawEdge(Me.hDC, r, edge, BF_RECT)
End Sub

